local ThePlayer = GLOBAL.ThePlayer
local TheInput = GLOBAL.TheInput
local TheNet = GLOBAL.TheNet

local yasuo_state = 0
local KEY_L = GLOBAL.KEY_L
AddModRPCHandler(modname, "L", function(player)
	if not player:HasTag("playerghost") and player.prefab == "yasuo" then
		if player.level < 15 then
			player.components.talker:Say("Level "..(player.level).."\nEXP  "..(player.xpnow).."/"..(5*(player.level + 1)))
		else
			player.components.talker:Say("Wind : Max!")
		end
	end
end)

local KEY_Z = GLOBAL.KEY_Z
AddModRPCHandler(modname, "Z", function(player)
	if not player:HasTag("playerghost") and player.prefab == "yasuo" then
		if yasuo_state ~= 0 then
			yasuo_state = 0

			player.AnimState:SetBuild("yasuo")
            player.components.locomotor.walkspeed =  math.ceil (4 * (player.level/100+1.05))
            player.components.locomotor.runspeed = math.ceil (6 * (player.level/100+1.05)) 
            player.components.health.absorb = 0
			player.sg:PushEvent("powerdown")
			player.SoundEmitter:PlaySound("dontstarve/common/fireOut")
--[[
            local huanyuan = GLOBAL.SpawnPrefab("yasuo_huanyuan")
            huanyuan.entity:SetParent(player.entity)
            huanyuan.Transform:SetPosition(0, 0.2, 0)
            huanyuan.Transform:SetScale(0.75,0.75, 0.75)
            --huanyuan.AnimState:PlayAnimation("action_hy",true)
            player:DoTaskInTime(0.6, function()
                huanyuan.kill_fx(huanyuan) 
                if inst.task then inst.task:Cancel() inst.task = nil end 
            end)
]]
            if player.components.combat.attack_damage_modifiers then
                player.components.combat.attack_damage_modifiers[1] = (uplayer.level/100*4/3-0.1)
            else
                player.components.combat.damagemultiplier = (1 * (player.level/100*2+0.9))
            end
            TUNING.SANITY_DAY_GAIN=(60 + player.level * 4)*0.1/480--100/(day_time*32),        
            TUNING.SANITY_NIGHT_LIGHT=-100/(60*20)+(60 + player.level * 4)*0.1/480
            TUNING.SANITY_NIGHT_MID=-100/(60*20)+(60 + player.level * 4)*0.1/480
            TUNING.SANITY_NIGHT_DARK=-100/(60*2)+(60 + player.level * 4)*0.1/480
            player.components.hunger:SetRate(75/480)--75/480s（每天下降75饥饿）
        end
	end
end)

local KEY_X = GLOBAL.KEY_X
AddModRPCHandler(modname, "X", function(player)
	if not player:HasTag("playerghost") and player.prefab == "yasuo" then
    	if player.level > 4 then 
    	  if yasuo_state ~= 1 then
    	  	yasuo_state = 1

            player.AnimState:SetBuild("yasuo_fy")
            player.components.locomotor.walkspeed =  math.ceil (4 * (player.level/100+0.9))
            player.components.locomotor.runspeed = math.ceil (6 * (player.level/100+0.9)) 
            player.components.health.absorb = 0.4
            player.sg:PushEvent("powerup")
			player.SoundEmitter:PlaySound("dontstarve/wilson/fireball_explo")
--[[
            local fangyu = GLOBAL.SpawnPrefab("yasuo_fangyu")
            fangyu.entity:SetParent(player.entity)
            fangyu.Transform:SetPosition(0, 0.2, 0)
            fangyu.Transform:SetScale(0.75,0.75, 0.75)
            fangyu.AnimState:PlayAnimation("action_fy",true)
            player:DoTaskInTime(0.6, function()
                fangyu.kill_fx(fangyu) 
                if inst.task then inst.task:Cancel() inst.task = nil end 
            end)
]]
            if player.components.combat.attack_damage_modifiers then
               player.components.combat.attack_damage_modifiers[1] = (player.level/100*4/3+0.1)
            else
                player.components.combat.damagemultiplier = (1 * (player.level/100*2+1.1))
            end
            TUNING.SANITY_DAY_GAIN=(60 + player.level * 4)*0.1/480--100/(day_time*32),        
            TUNING.SANITY_NIGHT_LIGHT=-100/(60*20)+(60 + player.level * 4)*0.1/480
            TUNING.SANITY_NIGHT_MID=-100/(60*20)+(60 + player.level * 4)*0.1/480
            TUNING.SANITY_NIGHT_DARK=-100/(60*2)+(60 + player.level * 4)*0.1/480
            player.components.hunger:SetRate(1)
          end
    	else
        	player.components.talker:Say("Need level-5!")
    	end
	end
end)

local KEY_C = GLOBAL.KEY_C
AddModRPCHandler(modname, "C", function(player)
	if not player:HasTag("playerghost") and player.prefab == "yasuo" then
    	if player.level > 9 then 
    	  if yasuo_state ~= 2 then
			yasuo_state = 2

        	player.AnimState:SetBuild("yasuo_gj")
        	player.components.locomotor.walkspeed =  math.ceil (4 * (player.level/100+1.20))
        	player.components.locomotor.runspeed = math.ceil (6 * (player.level/100+1.20)) 
        	player.components.health.absorb = -0.2
        	player.sg:PushEvent("powerup")
			player.SoundEmitter:PlaySound("dontstarve/wilson/fireball_explo")
--[[
        --local player = GetPlayer()
        local gongji = GLOBAL.SpawnPrefab("yasuo_gongji")
        gongji.entity:SetParent(player.entity)
        gongji.Transform:SetPosition(0, 0.2, 0)
        gongji.Transform:SetScale(0.75,0.75, 0.75)
        gongji.AnimState:PlayAnimation("action_gj",true)
        player:DoTaskInTime(0.6, function()
            gongji.kill_fx(gongji) 
            if inst.task then inst.task:Cancel() inst.task = nil end 
        end)
]]
        	if player.components.combat.attack_damage_modifiers then
            	player.components.combat.attack_damage_modifiers[1] = (player.level/100*4/3+0.1)
        	else
            	player.components.combat.damagemultiplier = (1 * (player.level/100*2+1.1))
        	end
        	TUNING.SANITY_DAY_GAIN=-1--100/(day_time*32),        
        	TUNING.SANITY_NIGHT_LIGHT=-100/(60*20)-1
        	TUNING.SANITY_NIGHT_MID=-100/(60*20)-1
        	TUNING.SANITY_NIGHT_DARK=-100/(60*2)-1
        	player.components.hunger:SetRate(75/480)--75/480s（每天下降75饥饿）
          end
    	else
        	player.components.talker:Say("Need level-10!")
    	end
	end
end)


local yasuo_handlers = {}
AddPlayerPostInit(function(inst)
	inst:DoTaskInTime(0, function()
		if inst == GLOBAL.ThePlayer then
			if inst.prefab == "yasuo" then
				yasuo_handlers[0] = TheInput:AddKeyDownHandler(KEY_L, function()
					SendModRPCToServer(MOD_RPC[modname]["L"])
				end)
				yasuo_handlers[1] = TheInput:AddKeyDownHandler(KEY_Z, function()
					SendModRPCToServer(MOD_RPC[modname]["Z"])
				end)
				yasuo_handlers[2] = TheInput:AddKeyDownHandler(KEY_X, function()
					SendModRPCToServer(MOD_RPC[modname]["X"])
				end)
				yasuo_handlers[3] = TheInput:AddKeyDownHandler(KEY_C, function()
					SendModRPCToServer(MOD_RPC[modname]["C"])
				end)
			else
				yasuo_handlers[0] = nil
				yasuo_handlers[1] = nil
				yasuo_handlers[2] = nil
				yasuo_handlers[3] = nil
			end
		end
	end)
end)